/* A Bison parser, made by GNU Bison 3.7.6.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

#ifndef YY_YY_GRAMMAR_H_INCLUDED
# define YY_YY_GRAMMAR_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    ANY = 258,                     /* ANY  */
    IP = 259,                      /* IP  */
    IF = 260,                      /* IF  */
    MAC = 261,                     /* MAC  */
    MPLS = 262,                    /* MPLS  */
    TOS = 263,                     /* TOS  */
    DIR = 264,                     /* DIR  */
    FLAGS = 265,                   /* FLAGS  */
    PROTO = 266,                   /* PROTO  */
    MASK = 267,                    /* MASK  */
    NET = 268,                     /* NET  */
    PORT = 269,                    /* PORT  */
    FWDSTAT = 270,                 /* FWDSTAT  */
    IN = 271,                      /* IN  */
    OUT = 272,                     /* OUT  */
    SRC = 273,                     /* SRC  */
    DST = 274,                     /* DST  */
    EQ = 275,                      /* EQ  */
    LT = 276,                      /* LT  */
    GT = 277,                      /* GT  */
    LE = 278,                      /* LE  */
    GE = 279,                      /* GE  */
    PREV = 280,                    /* PREV  */
    NEXT = 281,                    /* NEXT  */
    IDENT = 282,                   /* IDENT  */
    ENGINE_TYPE = 283,             /* ENGINE_TYPE  */
    ENGINE_ID = 284,               /* ENGINE_ID  */
    AS = 285,                      /* AS  */
    PACKETS = 286,                 /* PACKETS  */
    BYTES = 287,                   /* BYTES  */
    FLOWS = 288,                   /* FLOWS  */
    NFVERSION = 289,               /* NFVERSION  */
    PPS = 290,                     /* PPS  */
    BPS = 291,                     /* BPS  */
    BPP = 292,                     /* BPP  */
    DURATION = 293,                /* DURATION  */
    NOT = 294,                     /* NOT  */
    IPV4 = 295,                    /* IPV4  */
    IPV6 = 296,                    /* IPV6  */
    BGPNEXTHOP = 297,              /* BGPNEXTHOP  */
    ROUTER = 298,                  /* ROUTER  */
    VLAN = 299,                    /* VLAN  */
    CLIENT = 300,                  /* CLIENT  */
    SERVER = 301,                  /* SERVER  */
    APP = 302,                     /* APP  */
    LATENCY = 303,                 /* LATENCY  */
    SYSID = 304,                   /* SYSID  */
    ASA = 305,                     /* ASA  */
    DENIED = 306,                  /* DENIED  */
    XEVENT = 307,                  /* XEVENT  */
    XNET = 308,                    /* XNET  */
    XPORT = 309,                   /* XPORT  */
    INGRESS = 310,                 /* INGRESS  */
    EGRESS = 311,                  /* EGRESS  */
    ACL = 312,                     /* ACL  */
    ACE = 313,                     /* ACE  */
    XACE = 314,                    /* XACE  */
    NAT = 315,                     /* NAT  */
    ADD = 316,                     /* ADD  */
    EVENT = 317,                   /* EVENT  */
    VRF = 318,                     /* VRF  */
    NPORT = 319,                   /* NPORT  */
    NIP = 320,                     /* NIP  */
    PBLOCK = 321,                  /* PBLOCK  */
    START = 322,                   /* START  */
    END = 323,                     /* END  */
    STEP = 324,                    /* STEP  */
    SIZE = 325,                    /* SIZE  */
    STRING = 326,                  /* STRING  */
    REASON = 327,                  /* REASON  */
    NUMBER = 328,                  /* NUMBER  */
    PORTNUM = 329,                 /* PORTNUM  */
    ICMP_TYPE = 330,               /* ICMP_TYPE  */
    ICMP_CODE = 331,               /* ICMP_CODE  */
    OR = 332,                      /* OR  */
    AND = 333,                     /* AND  */
    NEGATE = 334                   /* NEGATE  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEMPTY -2
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define ANY 258
#define IP 259
#define IF 260
#define MAC 261
#define MPLS 262
#define TOS 263
#define DIR 264
#define FLAGS 265
#define PROTO 266
#define MASK 267
#define NET 268
#define PORT 269
#define FWDSTAT 270
#define IN 271
#define OUT 272
#define SRC 273
#define DST 274
#define EQ 275
#define LT 276
#define GT 277
#define LE 278
#define GE 279
#define PREV 280
#define NEXT 281
#define IDENT 282
#define ENGINE_TYPE 283
#define ENGINE_ID 284
#define AS 285
#define PACKETS 286
#define BYTES 287
#define FLOWS 288
#define NFVERSION 289
#define PPS 290
#define BPS 291
#define BPP 292
#define DURATION 293
#define NOT 294
#define IPV4 295
#define IPV6 296
#define BGPNEXTHOP 297
#define ROUTER 298
#define VLAN 299
#define CLIENT 300
#define SERVER 301
#define APP 302
#define LATENCY 303
#define SYSID 304
#define ASA 305
#define DENIED 306
#define XEVENT 307
#define XNET 308
#define XPORT 309
#define INGRESS 310
#define EGRESS 311
#define ACL 312
#define ACE 313
#define XACE 314
#define NAT 315
#define ADD 316
#define EVENT 317
#define VRF 318
#define NPORT 319
#define NIP 320
#define PBLOCK 321
#define START 322
#define END 323
#define STEP 324
#define SIZE 325
#define STRING 326
#define REASON 327
#define NUMBER 328
#define PORTNUM 329
#define ICMP_TYPE 330
#define ICMP_CODE 331
#define OR 332
#define AND 333
#define NEGATE 334

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 131 "grammar.y"

	uint64_t		value;
	char			*s;
	FilterParam_t	param;
	void			*list;

#line 232 "grammar.h"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAMMAR_H_INCLUDED  */
